#include <stdio.h>
#include <stdlib.h>
#include "include/m55800.h"

extern void asm_handler(void);
extern void routine_asm(void);
void activeInterruptTimer1(void);
void activeLeds(void);
void affSurLeds(unsigned char i);
void routine_c(void);
int cmp = 0;

StructTC * TC_1;
int cptSeconde=0;


// Structure PCB_t
typedef struct s_PCB
{
	unsigned handle;
	unsigned state;
	unsigned reg[15];
	unsigned psr;
	void* pc;
	unsigned spsr;
	struct s_PCB* next;	
	unsigned attente;
} PCB_t;

PCB_t *PPCB;
PCB_t pcb_idle, pcb_tache1, pcb_tache2, pcb_tache3;


void sleep(int t)
{
	PPCB->attente = t*100 ;
}

// Sheduler : deplace le pointeur PPCB
void scheduler(){
	PCB_t *temp = PPCB ;
	do
	{
		PPCB = PPCB->next;
	}while((PPCB->attente) > 0 && PPCB != temp);
	if(PPCB == temp && (PPCB->attente) > 0) 
	{
		PPCB = &pcb_idle ;
		PPCB->next = temp->next ;
	}
}

// tache 1
void tache1(){
	while(1)
	{
		affSurLeds(255);
		sleep(5) ;
	}
}

// tache 2
void tache2(){
	while(1)
	{
		affSurLeds(10);
	}
}

// tache 3
void tache3(){
	while(1)
	{
		affSurLeds(33);
		sleep(5) ;
	}
}

void idle(){
	while(1) 
	{
		affSurLeds(0) ;
	}
}

// handler 2eme version
void handler_C(){
	
	StructTCBlock* tcb0;
	PCB_t *temp = PPCB;
	PCB_t *temp2 = PPCB;
	if(temp2 == &pcb_idle){
		temp2 = PPCB->next;
		temp = PPCB->next;
	}
	
	tcb0 = TCB0_BASE;
	//affSurLeds(255);
	if(tcb0->TC[1].TC_SR)
	{
		cptSeconde++;
		do
		{
			if((temp->attente)>0) (temp->attente)--;
			temp=temp->next ;
		}
		while(temp != temp2);
		//affSurLeds(cptSeconde) ;
		if(cptSeconde >=100)
		{
			//affSurLeds(1) ;
			scheduler();
			cptSeconde=0;
		}
	}
}

int main(void)
{
	StructTCBlock* tcb0;		//utilisation du block 0 des controles timers (pour timer 1)
	tcb0 = TCB0_BASE;
	
	cmp = 0;
	activeInterruptTimer1();
	activeLeds();


	PPCB=&pcb_idle;
	pcb_idle.next 	= &pcb_tache1;
	pcb_idle.pc 	= (void*) idle;
	pcb_idle.psr 	= 0x13;
	pcb_idle.spsr = 0x93;
	pcb_idle.reg[13] = (unsigned)malloc(50*sizeof(unsigned)) ;
	pcb_idle.reg[13] += 50*4 ;
	pcb_idle.attente = 0;
	
	pcb_tache1.next = &pcb_tache2;
	pcb_tache1.pc 	= (void*) tache1;
	pcb_tache1.psr 	= 0x13;
	pcb_tache1.spsr = 0x93;
	pcb_tache1.reg[13] = (unsigned)malloc(50*sizeof(unsigned)) ;
	pcb_tache1.reg[13] += 50*4 ;
	pcb_tache1.attente = 0;
	
	pcb_tache2.next = &pcb_tache3;
	pcb_tache2.pc 	= (void*) tache2;
	pcb_tache2.psr 	= 0x13;
	pcb_tache2.spsr = 0x93;
	pcb_tache2.reg[13] = (unsigned)malloc(50*sizeof(unsigned)) ;
	pcb_tache2.reg[13] += 50*4 ;
	pcb_tache2.attente = 0;
	
	pcb_tache3.next = &pcb_tache1;
	pcb_tache3.pc 	= (void*) tache3;
	pcb_tache3.psr 	= 0x13;
	pcb_tache3.spsr = 0x93;
	pcb_tache3.reg[13] = (unsigned)malloc(50*sizeof(unsigned)) ;
	pcb_tache3.reg[13] += 50*4 ;
	pcb_tache3.attente = 0;
	
	while(1);
	
	return 0;
}

void activeInterruptTimer1(void)
{
	StructAIC* aic;
	StructAPMC* apmc;
	StructTCBlock* tcb0;		//utilisation du block 0 des controles timers (pour timer 1)
	
	/* Gestionnaire d'horloge */
	apmc = APMC_BASE;
	apmc->APMC_PCER = 0x0080; //activation horloge timers	
	
	/*Gestionnaire de timer 1*/
	tcb0 = TCB0_BASE;
	tcb0->TC[1].TC_RC=2500;		//valeur de comparaison  2500 pour gnrer une interruption
	tcb0->TC[1].TC_CMR = TC_CLKS_MCK128|TC_CPCTRG|TC_WAVE; //division de l'horloge par 128 (250KHz), trigger sur TC_RC, mode WAVE (pour les comparaisons)
	tcb0->TC[1].TC_IER = TC_CPCS;	//autorisation des interruption sur comparaison de TC_RC
	
	tcb0->TC[1].TC_CCR=TC_CLKEN|TC_SWTRG;	//Activation de l'horloge de TC1 et trigger logiciel pour demarage
	

	
	
	/* Configuration de l'AIC */
	aic = AIC_BASE;
	aic->AIC_SMR[7] = AIC_SRCTYPE_INT_LEVEL_SENSITIVE | 7; //interruption sur timer 1
	aic->AIC_SVR[7] = (int)asm_handler;
	aic->AIC_IECR = 1 << 7;		
}

void activeLeds(void)
{
	StructPIO* piob;
	int leds;
	
	piob = PIOB_BASE;
	leds = PB8 | PB9 | PB10 | PB11 | PB12 | PB13 | PB14 | PB15;
	
	piob->PIO_PER = leds;
	piob->PIO_OER = leds;
	piob->PIO_SODR = 0xFF << 8;
}

void affSurLeds(unsigned char i)
{
	StructPIO* piob;
	piob = PIOB_BASE;
	
	piob->PIO_CODR = i << 8;
	piob->PIO_SODR = ~(i << 8);
}

void routine_c(void)
{
	StructTCBlock* tcb0;
	static int compteur = 0;
	tcb0 = TCB0_BASE;
	
	if(tcb0->TC[1].TC_SR) //lecture et acquitement du timer status register
	{
		if(compteur >= 100)
		{
			cmp++;
			affSurLeds(cmp);
			compteur = 0;
		}
		else
		{
			compteur++;
		}
	}
}
