;----------------------------------------
;- AT91EB55 External Memories Definition
;----------------------------------------
;- Flash Memory : AT49BV1604 1Mx16

FLASH_BASE      EQU     0x01000000

EXT_SRAM_BASE   EQU     0x02000000
EXT_SRAM_SIZE   EQU     0x00040000              ; 256Kbytes
EXT_SRAM_LIMIT  EQU     (EXT_SRAM_BASE+EXT_SRAM_SIZE)

;------------------------------------------------------------------------------
;- EBI Initialization Data
;-------------------------
;- The EBI User Interface Image which is copied by the boot.
;- 25 MHz master clock assumed.
;- That's hardware! Details in the Electrical Datasheet of the AT91 device.
;- EBI Base Address is added at the end for commodity in copy code.
;------------------------------------------------------------------------------
EBI_CSR_0       EQU     (FLASH_BASE :OR: 0x2529)    ; 0x01000000, 16MB, 2 tdf, 16 bits, 3 WS
EBI_CSR_1       EQU     (EXT_SRAM_BASE :OR: 0x2121) ; 0x02000000, 16MB, 0 hold, 16 bits, 1 WS
EBI_CSR_2       EQU     0x20000000  ; unused
EBI_CSR_3       EQU     0x30000000  ; unused
EBI_CSR_4       EQU     0x40000000  ; unused
EBI_CSR_5       EQU     0x50000000  ; unused
EBI_CSR_6       EQU     0x60000000  ; unused
EBI_CSR_7       EQU     0x70000000  ; unused

            END
