

	MACRO
	IRQ_SYS_ENTRY
; sauvegarde de l'adresse de retour
	sub		r14, r14, #4
	stmfd	sp!, {r14}
; sauvegarde du SPSR et du registre r0 (pour le retour)
	mrs		r14, spsr
	stmfd	sp!, {r0, r14}
; on rautorise les interruption et l'on passe en mode system
	mrs		r14, cpsr
	bic		r14, r14, #I_BIT
	orr		r14, r14, #ARM_MODE_SYS
	msr_c	cpsr, r14
; on empile dans la pile utilisateur les registres corruptibles
	stmfd	sp!, {r1-r3, r12, r14}
	MEND
	
	MACRO
	IRQ_SYS_EXIT
; restauration des registres utilisateur
	ldmfd sp!, {r1-r3, r12, r14}	
; On repasse en mode irq avec interruption bloques
	mov		r0, cpsr
	bic		r0, #0x1F
	orr		r0, r0, #I_BIT:ARM_MODE_IRQ
	msr_c	cpsr, r0
; On acquitte l'AIC
	ldr		r0, =AIC_BASE
	str		r0, [r0, #AIC_EOICR]
; on restore les registres
	ldmfd	sp!, {r0, r14}
	msr		spsr_cxsf, r14
; retour d'interruption
	ldmfd	sp!, {pc}^
	MEND
