//USART
            .equ AT91_USART0, 0xFFFD0000

           .equ AT91_USART1, 0xFFFCC000

            .equ AT91_US_CR,  0x00  // Control register
            .equ AT91_US_CR_RxRESET, (1<<2)
            .equ AT91_US_CR_TxRESET, (1<<3)
            .equ AT91_US_CR_RxENAB,  (1<<4)
            .equ AT91_US_CR_RxDISAB, (1<<5)
            .equ AT91_US_CR_TxENAB,  (1<<6)
            .equ AT91_US_CR_TxDISAB, (1<<7)
            .equ AT91_US_CR_RSTATUS, (1<<8)
            .equ AT91_US_CR_STTTO ,  (1<<11)
            .equ AT91_US_MR  0x04 , // Mode register
            .equ AT91_US_MR_CLOCK ,  4
            .equ AT91_US_MR_CLOCK_MCK,  (0<<AT91_US_MR_CLOCK)
            .equ AT91_US_MR_CLOCK_MCK8, (1<<AT91_US_MR_CLOCK)
            .equ AT91_US_MR_CLOCK_SCK , (2<<AT91_US_MR_CLOCK)
            .equ AT91_US_MR_LENGTH,  6
            .equ AT91_US_MR_LENGTH_5,   (0<<AT91_US_MR_LENGTH)
            .equ AT91_US_MR_LENGTH_6,   (1<<AT91_US_MR_LENGTH)
            .equ AT91_US_MR_LENGTH_7,   (2<<AT91_US_MR_LENGTH)
            .equ AT91_US_MR_LENGTH_8,   (3<<AT91_US_MR_LENGTH)
            .equ AT91_US_MR_SYNC,    8
            .equ AT91_US_MR_SYNC_ASYNC, (0<<AT91_US_MR_SYNC)
            .equ AT91_US_MR_SYNC_SYNC  (1<<AT91_US_MR_SYNC)
            .equ AT91_US_MR_PARITY,  9
            .equ AT91_US_MR_PARITY_EVEN,  (0<<AT91_US_MR_PARITY)
            .equ AT91_US_MR_PARITY_ODD,   (1<<AT91_US_MR_PARITY)
            .equ AT91_US_MR_PARITY_SPACE, (2<<AT91_US_MR_PARITY)
            .equ AT91_US_MR_PARITY_MARK,  (3<<AT91_US_MR_PARITY)
            .equ AT91_US_MR_PARITY_NONE,  (4<<AT91_US_MR_PARITY)
            .equ AT91_US_MR_PARITY_MULTI, (6<<AT91_US_MR_PARITY)
            .equ AT91_US_MR_STOP,   12
            .equ AT91_US_MR_STOP_1,       (0<<AT91_US_MR_STOP)
            .equ AT91_US_MR_STOP_1_5     (1<<AT91_US_MR_STOP)
            .equ AT91_US_MR_STOP_2       (2<<AT91_US_MR_STOP)
            .equ AT91_US_MR_MODE   14
            .equ AT91_US_MR_MODE_NORMAL  (0<<AT91_US_MR_MODE)
            .equ AT91_US_MR_MODE_ECHO    (1<<AT91_US_MR_MODE)
            .equ AT91_US_MR_MODE_LOCAL   (2<<AT91_US_MR_MODE)
            .equ AT91_US_MR_MODE_REMOTE  (3<<AT91_US_MR_MODE)
            .equ AT91_US_MR_MODE9  17
            .equ AT91_US_MR_CLKO   18
            .equ AT91_US_IER 0x08  // Interrupt enable register
            .equ AT91_US_IER_RxRDY   (1<<0)  // Receive data ready
            .equ AT91_US_IER_TxRDY   (1<<1)  // Transmitter ready
            .equ AT91_US_IER_RxBRK   (1<<2)  // Break received
            .equ AT91_US_IER_ENDRX   (1<<3)  // Rx end
            .equ AT91_US_IER_ENDTX   (1<<4)  // Tx end
            .equ AT91_US_IER_OVRE    (1<<5)  // Rx overflow
            .equ AT91_US_IER_FRAME   (1<<6)  // Rx framing error
            .equ AT91_US_IER_PARITY  (1<<7)  // Rx parity
            .equ AT91_US_IER_TIMEOUT (1<<8)  // Rx timeout
            .equ AT91_US_IER_TxEMPTY (1<<9)  // Tx empty
            .equ AT91_US_IDR 0x0C  // Interrupt disable register
            .equ AT91_US_IMR 0x10  // Interrupt mask register
            .equ AT91_US_CSR 0x14  // Channel status register
            .equ AT91_US_CSR_RxRDY 0x01 // Receive data ready
            .equ AT91_US_CSR_TxRDY 0x02 // Transmit ready
            .equ AT91_US_CSR_RXBRK 0x04 // Transmit ready
            .equ AT91_US_CSR_ENDRX 0x08 // Transmit ready
            .equ AT91_US_CSR_ENDTX 0x10 // Transmit ready
            .equ AT91_US_CSR_OVRE  0x20 // Overrun error
            .equ AT91_US_CSR_FRAME 0x40 // Framing error
            .equ AT91_US_CSR_TIMEOUT 0x80 // Timeout
            .equ AT91_US_RHR 0x18  // Receive holding register
            .equ AT91_US_THR 0x1C  // Transmit holding register
            .equ AT91_US_BRG 0x20  // Baud rate generator
            .equ AT91_US_RTO 0x24  // Receive time out
            .equ AT91_US_TTG 0x28  // Transmit timer guard

// PDC US registers may have different addresses in at91 targets (i.e jtst)
           .equ AT91_US_RPR 0x30  // Receive pointer register

            .equ AT91_US_RCR 0x34  // Receive counter register


            .equ AT91_US_TPR 0x38  // Transmit pointer register
           .equ AT91_US_TCR 0x3c  // Transmit counter register
// macro could be different from target to target (i.e jtst)
//=============================================================================
// PIO


            .equ AT91_PIO      0xFFFF0000


            .equ AT91_PIO_PER  0x00  // PIO enable
            .equ AT91_PIO_PDR  0x04  // PIO disable
            .equ AT91_PIO_PSR  0x08  // PIO status

// PIOA
            .equ AT91_PIO_PSR_TCLK3   0x00000001 // Timer 3 Clock signal
            .equ AT91_PIO_PSR_TIOA3   0x00000002 // Timer 3 Signal A
            .equ AT91_PIO_PSR_TIOB3   0x00000004 // Timer 3 Signal B
            .equ AT91_PIO_PSR_TCLK4   0x00000008 // Timer 4 Clock signal
            .equ AT91_PIO_PSR_TIOA4   0x00000010 // Timer 4 Signal A
            .equ AT91_PIO_PSR_TIOB4   0x00000020 // Timer 4 Signal B
            .equ AT91_PIO_PSR_TCLK5   0x00000040 // Timer 5 Clock signal
            .equ AT91_PIO_PSR_TIOA5   0x00000080 // Timer 5 Signal A
            .equ AT91_PIO_PSR_TIOB5   0x00000100 // Timer 5 Signal B
            .equ AT91_PIO_PSR_IRQ0    0x00000200 // External Interrupt 0
            .equ AT91_PIO_PSR_IRQ1    0x00000400 // External Interrupt 1
            .equ AT91_PIO_PSR_IRQ2    0x00000800 // External Interrupt 2
            .equ AT91_PIO_PSR_IRQ3    0x00001000 // External Interrupt 3
            .equ AT91_PIO_PSR_FIQ     0x00002000 // Fast Interrupt
            .equ AT91_PIO_PSR_SCK0    0x00004000 // USART 0 Clock signal
            .equ AT91_PIO_PSR_TXD0    0x00008000 // USART 0 transmit data
            .equ AT91_PIO_PSR_RXD0    0x00010000 // USART 0 receive data
            .equ AT91_PIO_PSR_SCK1    0x00020000 // USART 1 Clock signal
            .equ AT91_PIO_PSR_TXD1    0x00040000 // USART 1 transmit data
            .equ AT91_PIO_PSR_RXD1    0x00080000 // USART 1 receive data
            .equ AT91_PIO_PSR_SCK2    0x00100000 // USART 2 Clock signal
            .equ AT91_PIO_PSR_TXD2    0x00200000 // USART 2 transmit data
            .equ AT91_PIO_PSR_RXD2    0x00400000 // USART 2 receive data
            .equ AT91_PIO_PSR_SPCK    0x00800000 // SPI Clock signal 
            .equ AT91_PIO_PSR_MISO    0x01000000 // SPI Master In Slave Out 
            .equ AT91_PIO_PSR_MOIS    0x02000000 // SPI Master Out Slave In 
            .equ AT91_PIO_PSR_NPCS0   0x04000000 // SPI Peripheral Chip Select 0
            .equ AT91_PIO_PSR_NPCS1   0x08000000 // SPI Peripheral Chip Select 1
            .equ AT91_PIO_PSR_NPCS2   0x10000000 // SPI Peripheral Chip Select 2
            .equ AT91_PIO_PSR_NPCS3   0x20000000 // SPI Peripheral Chip Select 3

            .equ AT91_PIO_PSR_IRQ4    0x00000008 // External Interrupt 4
            .equ AT91_PIO_PSR_IRQ5    0x00000010 // External Interrupt 5
            .equ AT91_PIO_PSR_AD0TRIG 0x00000040 // ADC0 External Trigger
            .equ AT91_PIO_PSR_AD1TRIG 0x00000080 // ADC1 External Trigger
            .equ AT91_PIO_PSR_BMS     0x00040000 // Boot Mode Select
            .equ AT91_PIO_PSR_TCLK0   0x00080000 // Timer 0 Clock signal
            .equ AT91_PIO_PSR_TIOA0   0x00100000 // Timer 0 Signal A
            .equ AT91_PIO_PSR_TIOB0   0x00200000 // Timer 0 Signal B
            .equ AT91_PIO_PSR_TCLK1   0x00400000 // Timer 1 Clock signal
            .equ AT91_PIO_PSR_TIOA1   0x00800000 // Timer 1 Signal A
            .equ AT91_PIO_PSR_TIOB1   0x01000000 // Timer 1 Signal B
            .equ AT91_PIO_PSR_TCLK2   0x02000000 // Timer 2 Clock signal
            .equ AT91_PIO_PSR_TIOA2   0x04000000 // Timer 2 Signal A
            .equ AT91_PIO_PSR_TIOB2   0x08000000 // Timer 2 Signal B


            .equ AT91_PIO_PSR_TCLK0    0x00000001 // Timer #0 clock
            .equ AT91_PIO_PSR_TIOA0    0x00000002 // Timer #0 signal A
            .equ AT91_PIO_PSR_TIOB0    0x00000004 // Timer #0 signal B
            .equ AT91_PIO_PSR_TCLK1    0x00000008 // Timer #1 clock
            .equ AT91_PIO_PSR_TIOA1    0x00000010 // Timer #1 signal A
            .equ AT91_PIO_PSR_TIOB1    0x00000020 // Timer #1 signal B
            .equ AT91_PIO_PSR_TCLK2    0x00000040 // Timer #2 clock
            .equ AT91_PIO_PSR_TIOA2    0x00000080 // Timer #2 signal A
            .equ AT91_PIO_PSR_TIOB2    0x00000100 // Timer #2 signal B
            .equ AT91_PIO_PSR_IRQ0     0x00000200 // IRQ #0
            .equ AT91_PIO_PSR_IRQ1     0x00000400 // IRQ #1
            .equ AT91_PIO_PSR_IRQ2     0x00000800 // IRQ #2
            .equ AT91_PIO_PSR_FIQ      0x00001000 // FIQ
            .equ AT91_PIO_PSR_SCK0     0x00002000 // Serial port #0 clock
            .equ AT91_PIO_PSR_TXD0     0x00004000 // Serial port #0 TxD
            .equ AT91_PIO_PSR_RXD0     0x00008000 // Serial port #0 RxD
            .equ AT91_PIO_PSR_P16      0x00010000 // PIO port #16
            .equ AT91_PIO_PSR_P17      0x00020000 // PIO port #17
            .equ AT91_PIO_PSR_P18      0x00040000 // PIO port #18
            .equ AT91_PIO_PSR_P19      0x00080000 // PIO port #19
            .equ AT91_PIO_PSR_SCK1     0x00100000 // Serial port #1 clock
            .equ AT91_PIO_PSR_TXD1     0x00200000 // Serial port #1 TxD
            .equ AT91_PIO_PSR_RXD1     0x00400000 // Serial port #1 RxD
            .equ AT91_PIO_PSR_P23      0x00800000 // PIO port #23
            .equ AT91_PIO_PSR_P24      0x01000000 // PIO port #24
            .equ AT91_PIO_PSR_MCKO     0x02000000 // Master clock out
            .equ AT91_PIO_PSR_NCS2     0x04000000 // Chip select #2
            .equ AT91_PIO_PSR_NCS3     0x08000000 // Chip select #3
            .equ AT91_PIO_PSR_CS7_A20  0x10000000 // Chip select #7 or A20
            .equ AT91_PIO_PSR_CS6_A21  0x20000000 // Chip select #6 or A21
            .equ AT91_PIO_PSR_CS5_A22  0x40000000 // Chip select #5 or A22
            .equ AT91_PIO_PSR_CS4_A23  0x80000000 // Chip select #4 or A23


            .equ AT91_PIO_OER  0x10  // Output enable
            .equ AT91_PIO_ODR  0x14  // Output disable
            .equ AT91_PIO_OSR  0x18  // Output status
            .equ AT91_PIO_IFER 0x20  // Input Filter enable
            .equ AT91_PIO_IFDR 0x24  // Input Filter disable
            .equ AT91_PIO_IFSR 0x28  // Input Filter status
            .equ AT91_PIO_SODR 0x30  // Set out bits
            .equ AT91_PIO_CODR 0x34  // Clear out bits
            .equ AT91_PIO_ODSR 0x38  // Output data status
            .equ AT91_PIO_PDSR 0x3C  // Pin data status
            .equ AT91_PIO_IER  0x40  // Interrupt enable
            .equ AT91_PIO_IDR  0x44  // Interrupt disable
            .equ AT91_PIO_IMR  0x48  // Interrupt mask
            .equ AT91_PIO_ISR  0x4C  // Interrupt status

//=============================================================================
// Advanced Interrupt Controller (AIC)

            .equ AT91_AIC      0xFFFFF000
            .equ AIC_BASE	   0xFFFFF000

            .equ AT91_AIC_SMR0   ((0*4)+0x000)
            .equ AT91_AIC_SMR1   ((1*4)+0x000)
            .equ AT91_AIC_SMR2   ((2*4)+0x000)
            .equ AT91_AIC_SMR3   ((3*4)+0x000)
            .equ AT91_AIC_SMR4   ((4*4)+0x000)
            .equ AT91_AIC_SMR5   ((5*4)+0x000)
            .equ AT91_AIC_SMR6   ((6*4)+0x000)
            .equ AT91_AIC_SMR7   ((7*4)+0x000)
            .equ AT91_AIC_SMR8   ((8*4)+0x000)
            .equ AT91_AIC_SMR9   ((9*4)+0x000)
            .equ AT91_AIC_SMR10  ((10*4)+0x000)
            .equ AT91_AIC_SMR11  ((11*4)+0x000)
            .equ AT91_AIC_SMR12  ((12*4)+0x000)
            .equ AT91_AIC_SMR13  ((13*4)+0x000)
            .equ AT91_AIC_SMR14  ((14*4)+0x000)
            .equ AT91_AIC_SMR15  ((15*4)+0x000)
            .equ AT91_AIC_SMR16  ((16*4)+0x000)
            .equ AT91_AIC_SMR17  ((17*4)+0x000)
            .equ AT91_AIC_SMR18  ((18*4)+0x000)
            .equ AT91_AIC_SMR19  ((19*4)+0x000)
            .equ AT91_AIC_SMR20  ((20*4)+0x000)
            .equ AT91_AIC_SMR21  ((21*4)+0x000)
            .equ AT91_AIC_SMR22  ((22*4)+0x000)
            .equ AT91_AIC_SMR23  ((23*4)+0x000)
            .equ AT91_AIC_SMR24  ((24*4)+0x000)
            .equ AT91_AIC_SMR25  ((25*4)+0x000)
            .equ AT91_AIC_SMR26  ((26*4)+0x000)
            .equ AT91_AIC_SMR27  ((27*4)+0x000)
            .equ AT91_AIC_SMR28  ((28*4)+0x000)
            .equ AT91_AIC_SMR29  ((29*4)+0x000)
            .equ AT91_AIC_SMR30  ((30*4)+0x000)
            .equ AT91_AIC_SMR31  ((31*4)+0x000)
            .equ AT91_AIC_SMR_LEVEL_LOW  (0<<5)
            .equ AT91_AIC_SMR_LEVEL_HI   (2<<5)
            .equ AT91_AIC_SMR_EDGE_NEG   (1<<5)
            .equ AT91_AIC_SMR_EDGE_POS   (3<<5)
            .equ AT91_AIC_SMR_PRIORITY   0x07
            .equ AT91_AIC_SVR0   ((0*4)+0x080)
            .equ AT91_AIC_SVR1   ((1*4)+0x080)
            .equ AT91_AIC_SVR2   ((2*4)+0x080)
            .equ AT91_AIC_SVR3   ((3*4)+0x080)
            .equ AT91_AIC_SVR4   ((4*4)+0x080)
            .equ AT91_AIC_SVR5   ((5*4)+0x080)
            .equ AT91_AIC_SVR6   ((6*4)+0x080)
            .equ AT91_AIC_SVR7   ((7*4)+0x080)
            .equ AT91_AIC_SVR8   ((8*4)+0x080)
            .equ AT91_AIC_SVR9   ((9*4)+0x080)
            .equ AT91_AIC_SVR10  ((10*4)+0x080)
            .equ AT91_AIC_SVR11  ((11*4)+0x080)
            .equ AT91_AIC_SVR12  ((12*4)+0x080)
            .equ AT91_AIC_SVR13  ((13*4)+0x080)
            .equ AT91_AIC_SVR14  ((14*4)+0x080)
            .equ AT91_AIC_SVR15  ((15*4)+0x080)
            .equ AT91_AIC_SVR16  ((16*4)+0x080)
            .equ AT91_AIC_SVR17  ((17*4)+0x080)
            .equ AT91_AIC_SVR18  ((18*4)+0x080)
            .equ AT91_AIC_SVR19  ((19*4)+0x080)
            .equ AT91_AIC_SVR20  ((20*4)+0x080)
            .equ AT91_AIC_SVR21  ((21*4)+0x080)
            .equ AT91_AIC_SVR22  ((22*4)+0x080)
            .equ AT91_AIC_SVR23  ((23*4)+0x080)
            .equ AT91_AIC_SVR24  ((24*4)+0x080)
            .equ AT91_AIC_SVR25  ((25*4)+0x080)
            .equ AT91_AIC_SVR26  ((26*4)+0x080)
            .equ AT91_AIC_SVR27  ((27*4)+0x080)
            .equ AT91_AIC_SVR28  ((28*4)+0x080)
            .equ AT91_AIC_SVR29  ((29*4)+0x080)
            .equ AT91_AIC_SVR30  ((30*4)+0x080)
            .equ AT91_AIC_SVR31  ((31*4)+0x080)
            .equ AT91_AIC_IVR    0x100
            .equ AT91_AIC_FVR    0x104
            .equ AT91_AIC_ISR    0x108
            .equ AT91_AIC_IPR    0x10C
            .equ AT91_AIC_IMR    0x110
            .equ AT91_AIC_CISR   0x114
            .equ AT91_AIC_IECR   0x120
            .equ AT91_AIC_IDCR   0x124
            .equ AT91_AIC_ICCR   0x128
            .equ AT91_AIC_ISCR   0x12C
            .equ AT91_AIC_EOI    0x130
            .equ AT91_AIC_SVR    0x134

            .equ AIC_SMR0   ((0*4)+0x000)
            .equ AIC_SMR1   ((1*4)+0x000)
            .equ AIC_SMR2   ((2*4)+0x000)
            .equ AIC_SMR3   ((3*4)+0x000)
            .equ AIC_SMR4   ((4*4)+0x000)
            .equ AIC_SMR5   ((5*4)+0x000)
            .equ AIC_SMR6   ((6*4)+0x000)
            .equ AIC_SMR7   ((7*4)+0x000)
            .equ AIC_SMR8   ((8*4)+0x000)
            .equ AIC_SMR9   ((9*4)+0x000)
            .equ AIC_SMR10  ((10*4)+0x000)
            .equ AIC_SMR11  ((11*4)+0x000)
            .equ AIC_SMR12  ((12*4)+0x000)
            .equ AIC_SMR13  ((13*4)+0x000)
            .equ AIC_SMR14  ((14*4)+0x000)
            .equ AIC_SMR15  ((15*4)+0x000)
            .equ AIC_SMR16  ((16*4)+0x000)
            .equ AIC_SMR17  ((17*4)+0x000)
            .equ AIC_SMR18  ((18*4)+0x000)
            .equ AIC_SMR19  ((19*4)+0x000)
            .equ AIC_SMR20  ((20*4)+0x000)
            .equ AIC_SMR21  ((21*4)+0x000)
            .equ AIC_SMR22  ((22*4)+0x000)
            .equ AIC_SMR23  ((23*4)+0x000)
            .equ AIC_SMR24  ((24*4)+0x000)
            .equ AIC_SMR25  ((25*4)+0x000)
            .equ AIC_SMR26  ((26*4)+0x000)
            .equ AIC_SMR27  ((27*4)+0x000)
            .equ AIC_SMR28  ((28*4)+0x000)
            .equ AIC_SMR29  ((29*4)+0x000)
            .equ AIC_SMR30  ((30*4)+0x000)
            .equ AIC_SMR31  ((31*4)+0x000)
            .equ AIC_SMR_LEVEL_LOW  (0<<5)
            .equ AIC_SMR_LEVEL_HI   (2<<5)
            .equ AIC_SMR_EDGE_NEG   (1<<5)
            .equ AIC_SMR_EDGE_POS   (3<<5)
            .equ AIC_SMR_PRIORITY   0x07
            .equ AIC_SVR0   ((0*4)+0x080)
            .equ AIC_SVR1   ((1*4)+0x080)
            .equ AIC_SVR2   ((2*4)+0x080)
            .equ AIC_SVR3   ((3*4)+0x080)
            .equ AIC_SVR4   ((4*4)+0x080)
            .equ AIC_SVR5   ((5*4)+0x080)
            .equ AIC_SVR6   ((6*4)+0x080)
            .equ AIC_SVR7   ((7*4)+0x080)
            .equ AIC_SVR8   ((8*4)+0x080)
            .equ AIC_SVR9   ((9*4)+0x080)
            .equ AIC_SVR10  ((10*4)+0x080)
            .equ AIC_SVR11  ((11*4)+0x080)
            .equ AIC_SVR12  ((12*4)+0x080)
            .equ AIC_SVR13  ((13*4)+0x080)
            .equ AIC_SVR14  ((14*4)+0x080)
            .equ AIC_SVR15  ((15*4)+0x080)
            .equ AIC_SVR16  ((16*4)+0x080)
            .equ AIC_SVR17  ((17*4)+0x080)
            .equ AIC_SVR18  ((18*4)+0x080)
            .equ AIC_SVR19  ((19*4)+0x080)
            .equ AIC_SVR20  ((20*4)+0x080)
            .equ AIC_SVR21  ((21*4)+0x080)
            .equ AIC_SVR22  ((22*4)+0x080)
            .equ AIC_SVR23  ((23*4)+0x080)
            .equ AIC_SVR24  ((24*4)+0x080)
            .equ AIC_SVR25  ((25*4)+0x080)
            .equ AIC_SVR26  ((26*4)+0x080)
            .equ AIC_SVR27  ((27*4)+0x080)
            .equ AIC_SVR28  ((28*4)+0x080)
            .equ AIC_SVR29  ((29*4)+0x080)
            .equ AIC_SVR30  ((30*4)+0x080)
            .equ AIC_SVR31  ((31*4)+0x080)
            .equ AIC_IVR    0x100
            .equ AIC_FVR    0x104
            .equ AIC_ISR    0x108
            .equ AIC_IPR    0x10C
            .equ AIC_IMR    0x110
            .equ AIC_CISR   0x114
            .equ AIC_IECR   0x120
            .equ AIC_IDCR   0x124
            .equ AIC_ICCR   0x128
            .equ AIC_ISCR   0x12C
            .equ AIC_EOICR    0x130
            .equ AIC_SVR    0x134
//=============================================================================
// Timer / counter


            .equ AT91_TC         0xFFFE0000

            .equ AT91_TC_TC0     0x00
            .equ AT91_TC_CCR     0x00
            .equ AT91_TC_CCR_CLKEN  0x01
            .equ AT91_TC_CCR_CLKDIS 0x02
            .equ AT91_TC_CCR_TRIG   0x04
// Channel Mode Register
            .equ AT91_TC_CMR		   0x04
            .equ AT91_TC_CMR_CLKS	   0
            .equ AT91_TC_CMR_CLKS_MCK2      (0<<0)
            .equ AT91_TC_CMR_CLKS_MCK8      (1<<0)
            .equ AT91_TC_CMR_CLKS_MCK32     (2<<0)
            .equ AT91_TC_CMR_CLKS_MCK128    (3<<0)
            .equ AT91_TC_CMR_CLKS_MCK1024   (4<<0)
            .equ AT91_TC_CMR_CLKS_XC0       (5<<0)
            .equ AT91_TC_CMR_CLKS_XC1       (6<<0)
            .equ AT91_TC_CMR_CLKS_XC2       (7<<0)
            .equ AT91_TC_CMR_CLKI           (1<<3)
            .equ AT91_TC_CMR_BURST_NONE     (0<<4)
            .equ AT91_TC_CMR_BURST_XC0      (1<<4)
            .equ AT91_TC_CMR_BURST_XC1      (2<<4)
            .equ AT91_TC_CMR_BURST_XC2      (3<<4)
// Capture mode definitions
            .equ AT91_TC_CMR_LDBSTOP        (1<<6)
            .equ AT91_TC_CMR_LDBDIS         (1<<7)
            .equ AT91_TC_CMR_TRIG_NONE      (0<<8)
            .equ AT91_TC_CMR_TRIG_NEG       (1<<8)
            .equ AT91_TC_CMR_TRIG_POS       (2<<8)
            .equ AT91_TC_CMR_TRIG_BOTH      (3<<8)
            .equ AT91_TC_CMR_EXT_TRIG_TIOB  (0<<10)
            .equ AT91_TC_CMR_EXT_TRIG_TIOA  (1<<10)
            .equ AT91_TC_CMR_CPCTRG         (1<<14)
            .equ AT91_TC_CMR_LDRA_NONE      (0<<16)
            .equ AT91_TC_CMR_LDRA_TIOA_NEG  (1<<16)
            .equ AT91_TC_CMR_LDRA_TIOA_POS  (2<<16)
            .equ AT91_TC_CMR_LDRA_TIOA_BOTH (3<<16)
            .equ AT91_TC_CMR_LDRB_NONE      (0<<18)
            .equ AT91_TC_CMR_LDRB_TIOA_NEG  (1<<18)
            .equ AT91_TC_CMR_LDRB_TIOA_POS  (2<<18)
            .equ AT91_TC_CMR_LDRB_TIOA_BOTH (3<<18)
// Waveform mode definitions
            .equ AT91_TC_CMR_CPCSTOP        (1<<6)
            .equ AT91_TC_CMR_CPCDIS	   (1<<7)
            .equ AT91_TC_CMR_EEVTEDG_NONE   (0<<8)
            .equ AT91_TC_CMR_EEVTEDG_NEG    (1<<8)
            .equ AT91_TC_CMR_EEVTEDG_POS    (2<<8)
            .equ AT91_TC_CMR_EEVTEDG_BOTH   (3<<8)
            .equ AT91_TC_CMR_EEVT_TIOB	   (0<<10)
            .equ AT91_TC_CMR_EEVT_XC0       (1<<10)
            .equ AT91_TC_CMR_EEVT_XC1       (2<<10)
            .equ AT91_TC_CMR_EEVT_XC2       (3<<10)
            .equ AT91_TC_CMR_ENETRG	   (1<<12)
            .equ AT91_TC_CMR_CPCTRG	   (1<<14)
            .equ AT91_TC_CMR_WAVE	   (1<<15)
            .equ AT91_TC_CMR_ACPA_NONE	   (0<<16)
            .equ AT91_TC_CMR_ACPA_SET	   (1<<16)
            .equ AT91_TC_CMR_ACPA_CLEAR	   (2<<16)
            .equ AT91_TC_CMR_ACPA_TOGGLE	   (3<<16)
            .equ AT91_TC_CMR_ACPC_NONE	   (0<<18)
            .equ AT91_TC_CMR_ACPC_SET	   (1<<18)
            .equ AT91_TC_CMR_ACPC_CLEAR	   (2<<18)
            .equ AT91_TC_CMR_ACPC_TOGGLE	   (3<<18)
            .equ AT91_TC_CMR_AEEVT_NONE	   (0<<20)
            .equ AT91_TC_CMR_AEEVT_SET	   (1<<20)
            .equ AT91_TC_CMR_AEEVT_CLEAR	   (2<<20)
            .equ AT91_TC_CMR_AEEVT_TOGGLE   (3<<20)
            .equ AT91_TC_CMR_ASWTRG_NONE	   (0<<22)
            .equ AT91_TC_CMR_ASWTRG_SET	   (1<<22)
            .equ AT91_TC_CMR_ASWTRG_CLEAR   (2<<22)
            .equ AT91_TC_CMR_ASWTRG_TOGGLE  (3<<22)
            .equ AT91_TC_CMR_BCPB_NONE	   (0<<24)
            .equ AT91_TC_CMR_BCPB_SET	   (1<<24)
            .equ AT91_TC_CMR_BCPB_CLEAR	   (2<<24)
            .equ AT91_TC_CMR_BCPB_TOGGLE	   (3<<24)
            .equ AT91_TC_CMR_BCPC_NONE	   (0<<26)
            .equ AT91_TC_CMR_BCPC_SET	   (1<<26)
            .equ AT91_TC_CMR_BCPC_CLEAR	   (2<<26)
            .equ AT91_TC_CMR_BCPC_TOGGLE	   (3<<26)
            .equ AT91_TC_CMR_BEEVT_NONE	   (0<<28)
            .equ AT91_TC_CMR_BEEVT_SET	   (1<<28)
            .equ AT91_TC_CMR_BEEVT_CLEAR	   (2<<28)
            .equ AT91_TC_CMR_BEEVT_TOGGLE   (3<<28)
            .equ AT91_TC_CMR_BSWTRG_NONE	   (0<<30)
            .equ AT91_TC_CMR_BSWTRG_SET	   (1<<30)
            .equ AT91_TC_CMR_BSWTRG_CLEAR   (2<<30)
            .equ AT91_TC_CMR_BSWTRG_TOGGLE  (3<<30)

            .equ AT91_TC_CV      0x10
            .equ AT91_TC_RA      0x14
            .equ AT91_TC_RB      0x18
            .equ AT91_TC_RC      0x1C
            .equ AT91_TC_SR      0x20
            .equ AT91_TC_SR_COVF    (1<<0)  // Counter overrun
            .equ AT91_TC_SR_LOVR    (1<<1)  // Load overrun
            .equ AT91_TC_SR_CPA     (1<<2)  // RA compare
            .equ AT91_TC_SR_CPB     (1<<3)  // RB compare
            .equ AT91_TC_SR_CPC     (1<<4)  // RC compare
            .equ AT91_TC_SR_LDRA    (1<<5)  // Load A status
            .equ AT91_TC_SR_LDRB    (1<<6)  // Load B status
            .equ AT91_TC_SR_EXT     (1<<7)  // External trigger
            .equ AT91_TC_SR_CLKSTA  (1<<16) // Clock enable/disable status
            .equ AT91_TC_SR_MTIOA   (1<<17) // TIOA mirror
            .equ AT91_TC_SR_MTIOB   (1<<18) // TIOB mirror
            .equ AT91_TC_IER     0x24
            .equ AT91_TC_IER_COVF   (1<<0)  // Counter overrun
            .equ AT91_TC_IER_LOVR   (1<<1)  // Load overrun
            .equ AT91_TC_IER_CPA    (1<<2)  // RA compare
            .equ AT91_TC_IER_CPB    (1<<3)  // RB compare
            .equ AT91_TC_IER_CPC    (1<<4)  // RC compare
            .equ AT91_TC_IER_LDRA   (1<<5)  // Load A status
            .equ AT91_TC_IER_LDRB   (1<<6)  // Load B status
            .equ AT91_TC_IER_EXT    (1<<7)  // External trigger
            .equ AT91_TC_IDR     0x28
            .equ AT91_TC_IMR     0x2C
            .equ AT91_TC_TC1     0x40
            .equ AT91_TC_TC2     0x80
            .equ AT91_TC_BCR     0xC0
            .equ AT91_TC_BCR_SYNC   0x01
            .equ AT91_TC_BMR     0xC4

//=============================================================================
// External Bus Interface

            .equ AT91_EBI        0xFFE00000

            .equ AT91_EBI_CSR0 	0x00
            .equ AT91_EBI_CSR1 	0x04
            .equ AT91_EBI_CSR2 	0x08
            .equ AT91_EBI_CSR3 	0x0C
            .equ AT91_EBI_CSR4 	0x10
            .equ AT91_EBI_CSR5 	0x14
            .equ AT91_EBI_CSR6 	0x18
            .equ AT91_EBI_CSR7 	0x1C  	   // Chip select
            .equ AT91_EBI_CSR_DBW_16 0x1    // Data bus 16 bits wide
            .equ AT91_EBI_CSR_DBW_8  0x2    // Data bus  8 bits wide
            .equ AT91_EBI_CSR_NWS_1  (0x0 << 2)
            .equ AT91_EBI_CSR_NWS_2  (0x1 << 2)
            .equ AT91_EBI_CSR_NWS_3  (0x2 << 2)
            .equ AT91_EBI_CSR_NWS_4  (0x3 << 2)
            .equ AT91_EBI_CSR_NWS_5  (0x4 << 2)
            .equ AT91_EBI_CSR_NWS_6  (0x5 << 2)
            .equ AT91_EBI_CSR_NWS_7  (0x6 << 2)
            .equ AT91_EBI_CSR_NWS_8  (0x7 << 2)	// Number of wait states
            .equ AT91_EBI_CSR_WSE    (0x1 << 5)	// Wait state enable
            .equ AT91_EBI_CSR_PAGES_1M  (0x0 << 7)
            .equ AT91_EBI_CSR_PAGES_4M  (0x1 << 7)
            .equ AT91_EBI_CSR_PAGES_16M (0x2 << 7)
            .equ AT91_EBI_CSR_PAGES_64M (0x3 << 7) // Page size
            .equ AT91_EBI_CSR_TDF_0  (0x0 << 9)
            .equ AT91_EBI_CSR_TDF_1  (0x1 << 9)
            .equ AT91_EBI_CSR_TDF_2  (0x2 << 9)
            .equ AT91_EBI_CSR_TDF_3  (0x3 << 9)
            .equ AT91_EBI_CSR_TDF_4  (0x4 << 9)
            .equ AT91_EBI_CSR_TDF_5  (0x5 << 9)
            .equ AT91_EBI_CSR_TDF_6  (0x6 << 9)
            .equ AT91_EBI_CSR_TDF_7  (0x7 << 9)	// Data float output time
            .equ AT91_EBI_CSR_BAT    (0x1 << 12) // Byte access type
            .equ AT91_EBI_CSR_CSEN   (0x1 << 13) // Chip select enable
            .equ AT91_EBI_CSR_BA     (0xFFF << 20) // Base address
            .equ AT91_EBI_RCR    0x20       // Reset control
            .equ AT91_EBI_RCR_RCB    0x1    // Remap command bit
            .equ AT91_EBI_MCR  	0x24  	   // Memory control
            .equ AT91_EBI_MCR_ALE_16M  0x0
            .equ AT91_EBI_MCR_ALE_8M   0x4
            .equ AT91_EBI_MCR_ALE_4M   0x5
            .equ AT91_EBI_MCR_ALE_2M   0x6
            .equ AT91_EBI_MCR_ALE_1M   0x7   // Address line enable
            .equ AT91_EBI_MCR_DRP      (0x1 << 4)  // Data read protocol


//=============================================================================
// Power Saving or Management


// Power Saving

            .equ AT91_PS         0xFFFF4000

            .equ AT91_PS_CR        0x000    // Control
            .equ AT91_PS_CR_CPU    (1<<0)   // Disable CPU clock (idle mode)
            .equ AT91_PS_PCER      0x004    // Peripheral clock enable
            .equ AT91_PS_PCDR      0x008    // Peripheral clock disable
            .equ AT91_PS_PCSR      0x00c    // Peripheral clock status

// (Advanced) Power Management

            .equ AT91_PMC        0xFFFF4000

            .equ AT91_PMC_SCER           0x00
            .equ AT91_PMC_SCDR           0x04
            .equ AT91_PMC_SCSR           0x08

            .equ AT91_PMC_PCER           0x10
            .equ AT91_PMC_PCDR           0x14
            .equ AT91_PMC_PCSR           0x18

            .equ AT91_PMC_CGMR           0x20
    
            .equ AT91_PMC_SR             0x30
            .equ AT91_PMC_IER            0x34
            .equ AT91_PMC_IDR            0x38
            .equ AT91_PMC_IMR            0x3c


            .equ AT91_PMC_PCER_US0       (1<<2)
            .equ AT91_PMC_PCER_US1       (1<<3)
            .equ AT91_PMC_PCER_SPIA      (1<<4)
            .equ AT91_PMC_PCER_SPIB      (1<<5)
            .equ AT91_PMC_PCER_TC0       (1<<6)
            .equ AT91_PMC_PCER_TC1       (1<<7)
            .equ AT91_PMC_PCER_TC2       (1<<8)
            .equ AT91_PMC_PCER_TC3       (1<<9)
            .equ AT91_PMC_PCER_TC4       (1<<10)
            .equ AT91_PMC_PCER_TC5       (1<<11)
            .equ AT91_PMC_PCER_PIOA      (1<<13)
            .equ AT91_PMC_PCER_PIOB      (1<<14)
    
            .equ AT91_PMC_CGMR_PRES_NONE       0
            .equ AT91_PMC_CGMR_PRES_DIV2       1
            .equ AT91_PMC_CGMR_PRES_DIV4       2
            .equ AT91_PMC_CGMR_PRES_DIV8       3
            .equ AT91_PMC_CGMR_PRES_DIV16      4
            .equ AT91_PMC_CGMR_PRES_DIV32      5
            .equ AT91_PMC_CGMR_PRES_DIV64      6
            .equ AT91_PMC_CGMR_PRES_RES        7
            .equ AT91_PMC_CGMR_PLLA         0x00
            .equ AT91_PMC_CGMR_PLLB         0x08
            .equ AT91_PMC_CGMR_MCK_SLCK   (0<<4)
            .equ AT91_PMC_CGMR_MCK_MCK    (1<<4)
            .equ AT91_PMC_CGMR_MCK_MCKINV (2<<4)
            .equ AT91_PMC_CGMR_MCK_MCKD2  (3<<4)
            .equ AT91_PMC_CGMR_MCKO_ENA   (0<<6)
            .equ AT91_PMC_CGMR_MCKO_DIS   (1<<6)
            .equ AT91_PMC_CGMR_CSS_SLCK   (0<<7)
            .equ AT91_PMC_CGMR_CSS_PLL    (1<<7)

            .equ AT91_PMC_CGMR_PLL_MUL(x) ((x)<<8)
            .equ AT91_PMC_CGMR_PLL_CNT(x) ((x)<<24)

            .equ AT91_PMC_SR_LOCK        0x01
    

            .equ AT91_PMC_PCER_US0       (1<<2)
            .equ AT91_PMC_PCER_US1       (1<<3)
            .equ AT91_PMC_PCER_US2       (1<<4)
            .equ AT91_PMC_PCER_SPI       (1<<5)
            .equ AT91_PMC_PCER_TC0       (1<<6)
            .equ AT91_PMC_PCER_TC1       (1<<7)
            .equ AT91_PMC_PCER_TC2       (1<<8)
            .equ AT91_PMC_PCER_TC3       (1<<9)
            .equ AT91_PMC_PCER_TC4       (1<<10)
            .equ AT91_PMC_PCER_TC5       (1<<11)
            .equ AT91_PMC_PCER_PIOA      (1<<13)
            .equ AT91_PMC_PCER_PIOB      (1<<14)
            .equ AT91_PMC_PCER_ADC0      (1<<15)
            .equ AT91_PMC_PCER_ADC1      (1<<16)
            .equ AT91_PMC_PCER_DAC0      (1<<17)
            .equ AT91_PMC_PCER_DAC1      (1<<18)

            .equ AT91_PMC_CGMR_MOSC_XTAL       0
            .equ AT91_PMC_CGMR_MOSC_BYP        1
            .equ AT91_PMC_CGMR_MOSC_DIS   (0<<1)
            .equ AT91_PMC_CGMR_MOSC_ENA   (1<<1)
            .equ AT91_PMC_CGMR_MCKO_ENA   (0<<2)
            .equ AT91_PMC_CGMR_MCKO_DIS   (1<<2)
            .equ AT91_PMC_CGMR_PRES_NONE  (0<<4)
            .equ AT91_PMC_CGMR_PRES_DIV2  (1<<4)
            .equ AT91_PMC_CGMR_PRES_DIV4  (2<<4)
            .equ AT91_PMC_CGMR_PRES_DIV8  (3<<4)
            .equ AT91_PMC_CGMR_PRES_DIV16 (4<<4)
            .equ AT91_PMC_CGMR_PRES_DIV32 (5<<4)
            .equ AT91_PMC_CGMR_PRES_DIV64 (6<<4)
            .equ AT91_PMC_CGMR_PRES_RES   (7<<4)
            .equ AT91_PMC_CGMR_CSS_LF     (0<<14)
            .equ AT91_PMC_CGMR_CSS_MOSC   (1<<14)
            .equ AT91_PMC_CGMR_CSS_PLL    (2<<14)
            .equ AT91_PMC_CGMR_CSS_RES    (3<<14)
    
            .equ AT91_PMC_CGMR_PLL_MUL(x) ((x)<<8)
            .equ AT91_PMC_CGMR_OSC_CNT(x) ((x)<<16)
            .equ AT91_PMC_CGMR_PLL_CNT(x) ((x)<<24)

            .equ AT91_PMC_PCR            0x28
            .equ AT91_PMC_PCR_SHDALC     1
            .equ AT91_PMC_PCR_WKACKC     2
    
            .equ AT91_PMC_PMR            0x2c
            .equ AT91_PMC_PMR_SHDALS_TRI         0
            .equ AT91_PMC_PMR_SHDALS_LEVEL0      1
            .equ AT91_PMC_PMR_SHDALS_LEVEL1      2
            .equ AT91_PMC_PMR_SHDALS_RES         3
            .equ AT91_PMC_PMR_WKACKS_TRI    (0<<2)
            .equ AT91_PMC_PMR_WKACKS_LEVEL0 (1<<2)
            .equ AT91_PMC_PMR_WKACKS_LEVEL1 (2<<2)
            .equ AT91_PMC_PMR_WKACKS_RES    (3<<2)
            .equ AT91_PMC_PMR_ALWKEN        (1<<4)
            .equ AT91_PMC_PMR_ALSHEN        (1<<5)

            .equ AT91_PMC_PMR_WKEDG_NONE    (0<<6)
            .equ AT91_PMC_PMR_WKEDG_POS     (1<<6)
            .equ AT91_PMC_PMR_WKEDG_NEG     (2<<6)
            .equ AT91_PMC_PMR_WKEDG_BOTH    (3<<6)

            .equ AT91_PMC_SR_MOSCS       0x01
            .equ AT91_PMC_SR_LOCK        0x02


//=============================================================================
// Watchdog

            .equ AT91_WD             0xFFFF8000

            .equ AT91_WD_OMR         0x00
            .equ AT91_WD_OMR_WDEN    0x00000001
            .equ AT91_WD_OMR_RSTEN   0x00000002
            .equ AT91_WD_OMR_IRQEN   0x00000004
            .equ AT91_WD_OMR_EXTEN   0x00000008
            .equ AT91_WD_OMR_OKEY    (0x00000234 << 4)
            .equ AT91_WD_CMR         0x04
            .equ AT91_WD_CMR_WDCLKS  0x00000003
            .equ AT91_WD_CMR_HPCV    0x0000003C
            .equ AT91_WD_CMR_CKEY    (0x0000006E << 7)
            .equ AT91_WD_CR          0x08
            .equ AT91_WD_CR_RSTKEY   0x0000C071
            .equ AT91_WD_SR          0x0C
            .equ AT91_WD_SR_WDOVF    0x00000001

//=============================================================================
// SPI 

            .equ AT91_SPI               0xFFFBC000

            .equ AT91_SPI_CR            0x00              // Control Register 
            .equ AT91_SPI_CR_SPIEN      0x00000001        // SPI Enable
            .equ AT91_SPI_CR_SPIDIS     0x00000002        // SPI Disable
            .equ AT91_SPI_CR_SWRST      0x00000080        // SPI Software reset
            .equ AT91_SPI_MR            0x04              // Mode Register
            .equ AT91_SPI_MR_MSTR       0x00000001        // Master/Slave Mode 
            .equ AT91_SPI_MR_PS         0x00000002        // Peripheral Select
            .equ AT91_SPI_MR_PCSDEC     0x00000004        // Chip Select Decode
            .equ AT91_SPI_MR_DIV32      0x00000008        // Clock Selection 
            .equ AT91_SPI_MR_LLB        0x00000080        // Local Loopback Enable
            .equ AT91_SPI_MR_PCS(x)     (((x)&0x0F)<<16)  // Peripheral Chip Select
            .equ AT91_SPI_MR_DLYBCS(x)  (((x)&0xFF)<<24)  // Delay Between Chip Selects
            .equ AT91_SPI_RDR           0x08              // Receive Data Register
            .equ AT91_SPI_TDR           0x0C              // Transmit Data Register
            .equ AT91_SPI_SR            0x10              // Status Register
            .equ AT91_SPI_SR_RDRF       0x00000001        // Receive Data Register Full
            .equ AT91_SPI_SR_TDRE       0x00000002        // Transmit Data Register Empty
            .equ AT91_SPI_SR_MODF       0x00000004        // Mode Fault Error
            .equ AT91_SPI_SR_OVRES      0x00000008        // Overrun Error Status
            .equ AT91_SPI_SR_ENDRX      0x00000010        // End of Receiver Transfer
            .equ AT91_SPI_SR_ENDTX      0x00000020        // End of Transmitter Transfer
            .equ AT91_SPI_SR_SPIENS     0x00010000        // SPI Enable Status
            .equ AT91_SPI_IER           0x14              // Interrupt Enable Register
            .equ AT91_SPI_IDR           0x18              // Interrupt Disable Register
            .equ AT91_SPI_IMR           0x1C              // Interrupt Mask Register
// DMA registers are PDC registers
// can be different from target to target
            .equ AT91_SPI_RPR           0x20              // Receive Pointer Register
            .equ AT91_SPI_RCR           0x24              // Receive Counter Register
            .equ AT91_SPI_TPR           0x28              // Transmit Pointer Register
            .equ AT91_SPI_TCR           0x2C              // Transmit Counter Register
            .equ AT91_SPI_CSR0          0x30              // Chip Select Register 0
            .equ AT91_SPI_CSR1          0x34              // Chip Select Register 1
            .equ AT91_SPI_CSR2          0x38              // Chip Select Register 2
            .equ AT91_SPI_CSR3          0x3C              // Chip Select Register 3
            .equ AT91_SPI_CSR_CPOL      0x00000001        // Clock Polarity
            .equ AT91_SPI_CSR_NCPHA     0x00000002        // Clock Phase
            .equ AT91_SPI_CSR_BITS(x)   (((x)&0x0F)<<4)   // Bits Per Transfer
            .equ AT91_SPI_CSR_BITS8     AT91_SPI_CSR_BITS(0)
            .equ AT91_SPI_CSR_BITS9     AT91_SPI_CSR_BITS(1)
            .equ AT91_SPI_CSR_BITS10    AT91_SPI_CSR_BITS(2)
            .equ AT91_SPI_CSR_BITS11    AT91_SPI_CSR_BITS(3)
            .equ AT91_SPI_CSR_BITS12    AT91_SPI_CSR_BITS(4)
            .equ AT91_SPI_CSR_BITS13    AT91_SPI_CSR_BITS(5)
            .equ AT91_SPI_CSR_BITS14    AT91_SPI_CSR_BITS(6)
            .equ AT91_SPI_CSR_BITS15    AT91_SPI_CSR_BITS(7)
            .equ AT91_SPI_CSR_BITS16    AT91_SPI_CSR_BITS(8)
            .equ AT91_SPI_CSR_SCBR(x)   (((x)&0xFF)<<8)   // Serial Clock Baud Rate 
            .equ AT91_SPI_CSR_DLYBS(x)  (((x)&0xFF)<<16)  // Delay Before SPCK
            .equ AT91_SPI_CSR_DLYBCT(x) (((x)&0xFF)<<24)  // Delay Between two transfers
 
 
            .equ AT91_SPI_PIO         AT91_PIOA
            .equ AT91_SPI_PIO_NPCS(x) (((x)&0x0F)<<26)

