AIC_BASE 		equ 0xFFFFF000
AIC_EOICR		equ 0x130
TC1_BASE		equ 0xFFFD0040
TC_SR			equ 0x20

	EXPORT asm_handler
	IMPORT handler_C
	IMPORT	PPCB
	AREA timer_handler, CODE, READONLY

asm_handler
;/* Sauvegarde du registre le lien dans la pile irq */
	SUB		lr, lr, #4
	STMFD	sp!, {lr}
;	/* sauvegarde des registre commun  tous les modes dans le PCB courant*/
	LDR		r14, PPCB
	ADD		r14,r14,#8
	STMIA	r14,{r0-r7}
;/* rcupration du spsr et du pc pour sauvegarde */
	LDMFD	sp!, {r1}
	STR		r1,[r14, # ((15*4)+4)]
	MRS		r0, SPSR
	STR		r0,[r14, # (15*4)]	
	ADD		r3, r14	, #(8*4)	;	/* pointeur sur le champ reg[8] la structure PCB */	
	MSR		cpsr_c, #0x93	; /* Mode svc */
	STMIA	r3!,{r8-r14}	;/* sauvegarde des registres */
;	/* sauvegarde du spsr  du mode */
	MRS		r4, SPSR
	STR		r4, [r3,#8]
;/* on rautorise les irq */
	MSR		cpsr_c, #0x13	;/* irq et fiq autorises */
	
	; /* on acquitte le timer */
	ldr		r14, =TC1_BASE
	ldr		r14,[r14, #TC_SR]	
	
;/*On appelle le sheduler*/
	BL		handler_C
	
;/* On bloque les irq */
	MSR		cpsr_c, #0x93	
;/* rcupration de psr et pc */

	LDR		r0, PPCB
	ADD		r0, r0, #(8+(15*4))	;/* on ajuste le pointeur sur psr*/
	LDMIA 	r0,{r4-r6}	;/* on rcupre PSR, PC et SPSR*/
;/*restauration du SPSR du mode svc */
	MSR		spsr_cxsf, r6
;/* restauration r8-r14 */
	LDMDB	r0!, {r8-r14}		
;/* passage en mode irq */ 
	MSR		cpsr_cxsf, #0x92
;/* restauration du psr de la tche*/
	MSR		spsr_cxsf, r4
;/* l'adresse de retour dans la pile */
	STMFD 	sp!, {r5}	
;/* restauration du reste des registres */
	MOV 	r14, r0
	LDMDB	r14!, {r0-r7}
	
;/* retour d'interruption */
ack
	;/* On acquitte l'AIC */
	LDR		r14, =AIC_BASE
	STR		r0, [r14, #AIC_EOICR]
	;/*retour d'interruption (restauration de la nouvelle thce)*/
	LDMFD	sp!, {pc}^

	END
		